#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_color2 Red
//---- input parameters
extern int    rsiPeriod = 10;
//---- buffers
double buySignal[];
double sellSignal[];

static datetime lastAlertTime;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexStyle(1, DRAW_ARROW);

   SetIndexBuffer(0, buySignal);
   SetIndexBuffer(1, sellSignal);

   SetIndexEmptyValue(0, 0.0);
   SetIndexEmptyValue(1, 0.0);
   
   SetIndexArrow(0, 233);
   SetIndexArrow(1, 234);
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int LastAction = 0;

   for (int i = Bars - IndicatorCounted(); i >= 0; i--)
   {
      
      double rsi1 = iRSI(NULL, 0, rsiPeriod, PRICE_CLOSE, i+1);
      double rsi2 = iRSI(NULL, 0, rsiPeriod, PRICE_CLOSE, i+2);
      double displacement = GetArrowDisplacement(i);
   
      if (rsi1>40&&rsi2<40||rsi1>50&&rsi2<50)
      {
         if(LastAction != 1) buySignal[i+1] = Low[i+1] - displacement;
         LastAction = 1;
      }
      
      if (rsi1<50&&rsi2>50||rsi1<40&&rsi2>40)
      {
         if(LastAction != 2) sellSignal[i+1] = High[i+1] + displacement;
         LastAction = 2;
      }      

   }

   return(0);
}
//+------------------------------------------------------------------+
void SignalAlert(string message)
{
   if (Time[0] != lastAlertTime)
   {
      Alert(message, Symbol(), ", ", Period(), " Minutes chart");
      lastAlertTime = Time[0];
   }
}
//+------------------------------------------------------------------+
double GetArrowDisplacement(int i)
{
   double high = iMA(NULL, 0, 10, 0, MODE_SMA, PRICE_HIGH, i);
   double low = iMA(NULL, 0, 10, 0, MODE_SMA, PRICE_LOW, i);
   
   return ((high - low) / 2);
}